<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>cachedb_cassandra Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284021"></a>cachedb_cassandra Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3></div></div></div><div><p class="copyright">Copyright © 2011 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id271625">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248034">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284079">1.2. Advantages</a></span></dt><dt><span class="section"><a href="#id249578">1.3. Limitations</a></span></dt><dt><span class="section"><a href="#id249601">1.4. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249606">1.4.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249615">1.4.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248387">1.5. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248393">1.5.1. <code class="varname">cachedb_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id248443">1.5.2. <code class="varname">connection_timeout</code> (int)</a></span></dt><dt><span class="section"><a href="#id293405">1.5.3. <code class="varname">send_timeout</code> (int)</a></span></dt><dt><span class="section"><a href="#id293433">1.5.4. <code class="varname">receive_timeout</code> (int)</a></span></dt><dt><span class="section"><a href="#id293459">1.5.5. <code class="varname">wr_consistency_level</code> (int)</a></span></dt><dt><span class="section"><a href="#id293566">1.5.6. <code class="varname">rd_consistency_level</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293595">1.6. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293605">1.7. Known issues</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248407">Set <code class="varname">cachedb_url</code> parameter</a></dt><dt>1.2. <a href="#id248428">Use Cassandra servers </a></dt><dt>1.3. <a href="#id248454">Set <code class="varname">connection_timeout</code> parameter</a></dt><dt>1.4. <a href="#id293417">Set <code class="varname">send_timeout</code> parameter</a></dt><dt>1.5. <a href="#id293443">Set <code class="varname">receive_timeout</code> parameter</a></dt><dt>1.6. <a href="#id293550">Set <code class="varname">wr_consistency_level</code> parameter</a></dt><dt>1.7. <a href="#id293578">Set <code class="varname">rd_consistency_level</code> parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id271625"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248034"></a>1.1. Overview</h2></div></div></div><p>
		This module is an implementation of a cache system designed to work with
		Cassandra servers.
		It uses the Key-Value interface exported from the core.
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284079"></a>1.2. Advantages</h2></div></div></div><p>
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>memory costs are no longer on the server
				</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>many servers can be used inside a cluster, so the memory
				is virtually unlimited</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>the cache is 100% persistent. A restart
					of OpenSIPS server will not affect the DB. The Cassandra DB is also
				persistent so it can also be restarted without loss of information.</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>Cassandra is an open-source project so
				it can be used to exchange data
				 with various other applicationsr</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>By creating a Cassandra Cluster, multiple OpenSIPS
				instances can easily share key-value information</em></span>
			</p></li></ul></div><p>
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249578"></a>1.3. Limitations</h2></div></div></div><p>
			</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>
		keys (in key:value pairs) may not contain spaces or control characters
		</em></span>
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249601"></a>1.4. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249606"></a>1.4.1. OpenSIPS Modules</h3></div></div></div><p>
		None.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249615"></a>1.4.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>thrift 0.6.1</em></span>
			</p><p>
				Thrift 0.6.1 can be downloaded from http://archive.apache.org/dist/thrift/
				Download the archive, extract sources, run ./configure,make,sudo make install.
			</p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248387"></a>1.5. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248393"></a>1.5.1. <code class="varname">cachedb_url</code> (string)</h3></div></div></div><p>
			The urls of the server groups that OpenSIPS will connect to in order
			to use the from script cache_store,cache_fetch, etc operations.
			It can be set more than one time.
			The prefix part of the URL will be the identifier that will be used
			from the script.

			The database part of the URL needs to be in the format Keyspace_ColumnFamily_CounterFamily
		</p><div class="example"><a name="id248407"></a><p class="title"><b>Example 1.1. Set <code class="varname">cachedb_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_cassandra", "cachedb_url","cassandra:group1://localhost:9061/Keyspace1_Users_Counters");
modparam("cachedb_cassandra", "cachedb_url","cassandra:cluster1://random_url:8888/Keyspace2_Keys_CounterF");
...
	</pre></div></div><br class="example-break"><div class="example"><a name="id248428"></a><p class="title"><b>Example 1.2. Use Cassandra servers </b></p><div class="example-contents"><pre class="programlisting">
...
cache_store("cassandra:group1","key","$ru value");
cache_fetch("cassandra:cluster1","key",$avp(10));
cache_remove("cassandra:cluster1","key");
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248443"></a>1.5.2. <code class="varname">connection_timeout</code> (int)</h3></div></div></div><p>
			The timeout in ms that will be triggered in case a connection attempt fails.
		</p><div class="example"><a name="id248454"></a><p class="title"><b>Example 1.3. Set <code class="varname">connection_timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_cassandra", "connection_timeout",1000);
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293405"></a>1.5.3. <code class="varname">send_timeout</code> (int)</h3></div></div></div><p>
			The timeout in ms that will be triggered in case a Cassandra write takes too long
		</p><div class="example"><a name="id293417"></a><p class="title"><b>Example 1.4. Set <code class="varname">send_timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_cassandra", "send_timeout",1000);
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293433"></a>1.5.4. <code class="varname">receive_timeout</code> (int)</h3></div></div></div><p>
			The timeout in ms that will be triggered in case a Cassandra read takes too long
		</p><div class="example"><a name="id293443"></a><p class="title"><b>Example 1.5. Set <code class="varname">receive_timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_cassandra", "receive_timeout",1000);
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293459"></a>1.5.5. <code class="varname">wr_consistency_level</code> (int)</h3></div></div></div><p>
			The consistency level desired for write operations.
			Options are :
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>1</em></span> - Ensure that the write has been written to at least 1 replica's commit log and memory table before responding to the client.
			</p></li><li><p><span class="emphasis"><em>2</em></span> - Ensure that the write has been written to N / 2 + 1 replicas before responding to the client.
			</p></li><li><p><span class="emphasis"><em>3</em></span> - Ensure that the write has been written to ReplicationFactor / 2 + 1 nodes, within the local datacenter (requires NetworkTopologyStrategy)
			</p></li><li><p><span class="emphasis"><em>4</em></span> - Ensure that the write has been written to ReplicationFactor / 2 + 1 nodes in each datacenter (requires NetworkTopologyStrategy)
			</p></li><li><p><span class="emphasis"><em>5</em></span> - Ensure that the write is written to all N replicas before responding to the client. Any unresponsive replicas will fail the operation. 
			</p></li><li><p><span class="emphasis"><em>6</em></span> - Ensure that the write has been written to at least 1 node, including HintedHandoff recipients. 
			</p></li><li><p><span class="emphasis"><em>7</em></span> - Ensure that the write has been written to at least 2 replica's before responding to the client.
			</p></li><li><p><span class="emphasis"><em>8</em></span> - Ensure that the write has been written to at least 3 replica's before responding to the client.
			</p></li></ul></div><p>

		Default is 1
		</p><div class="example"><a name="id293550"></a><p class="title"><b>Example 1.6. Set <code class="varname">wr_consistency_level</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_cassandra", "wr_consistency_level",7);
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293566"></a>1.5.6. <code class="varname">rd_consistency_level</code> (int)</h3></div></div></div><p>
			The consistency level desired for read operations.
			Options are the same as for write consistency level.
		</p><div class="example"><a name="id293578"></a><p class="title"><b>Example 1.7. Set <code class="varname">rd_consistency_level</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_cassandra", "rd_consistency_level",7);
...
	</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293595"></a>1.6. Exported Functions</h2></div></div></div><p>The module does not export functions to be used
		in configuration script.</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293605"></a>1.7. Known issues</h2></div></div></div><p>
		Due to the fact that Cassandra cannot store counters and regular columns in the same ColumnFamily, add() and sub() methods are not exported through the Key-Value interface. 
		</p><p>
		Also, the module does not currently support Authentication.
		</p><p>
		Future realeases of this module will address this issue.
		</p></div></div></div></body></html>
