<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Presence_CallInfo Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284025"></a>Presence_CallInfo Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3><code class="email">&lt;<a class="email" href="mailto:osas@voipembedded.com">osas@voipembedded.com</a>&gt;</code></div><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3><code class="email">&lt;<a class="email" href="mailto:bogdan@opensips.org">bogdan@opensips.org</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3><code class="email">&lt;<a class="email" href="mailto:osas@voipembedded.com">osas@voipembedded.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3><code class="email">&lt;<a class="email" href="mailto:bogdan@opensips.org">bogdan@opensips.org</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2010-2013 
				<a class="ulink" href="http://www.voipembedded.com" target="_top">VoIP Embedded, Inc.</a>
			, <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 7754 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id249271">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248989">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248003">1.2. Usage modes</a></span></dt><dd><dl><dt><span class="section"><a href="#id249592">1.2.1. External publishing</a></span></dt><dt><span class="section"><a href="#id249635">1.2.2. Internal publishing</a></span></dt></dl></dd><dt><span class="section"><a href="#id293400">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id293405">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id293437">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id293448">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id293453">1.4.1. <code class="varname">call_info_timeout_notification</code> (int)</a></span></dt><dt><span class="section"><a href="#id293486">1.4.2. <code class="varname">line_seize_timeout_notification</code> (int)</a></span></dt><dt><span class="section"><a href="#id293520">1.4.3. <code class="varname">disable_dialog_support_for_sca</code> (int)</a></span></dt><dt><span class="section"><a href="#id293556">1.4.4. <code class="varname">line_hash_size</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293597">1.5. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293602">1.5.1. 
			<code class="function">sca_set_calling_line([line])</code>
			</a></span></dt><dt><span class="section"><a href="#id293643">1.5.2. 
			<code class="function">sca_set_called_line([line])</code>
			</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id293471">Set <code class="varname">call_info_timeout_notification</code> parameter</a></dt><dt>1.2. <a href="#id293504">Set <code class="varname">line_seize_timeout_notification</code> parameter</a></dt><dt>1.3. <a href="#id293540">Set <code class="varname">disable_dialog_support_for_sca</code> parameter</a></dt><dt>1.4. <a href="#id293580">Set <code class="varname">line_hash_size</code> parameter</a></dt><dt>1.5. <a href="#id293626"><code class="function">sca_set_calling_line()</code> usage</a></dt><dt>1.6. <a href="#id293667"><code class="function">sca_set_called_line()</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id249271"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248989"></a>1.1. Overview</h2></div></div></div><p>
		This module provides OpenSIPS support for shared call appearances (SCA)
		as defined by BroadWorks SIP Access Side Extensions Interface specifications.
		The SCA mechanism is a fundamental building block for a variety of enhanced 
		telephony services. Features like attendant console, line extensions,
		and key system emulation cannot be delivered without some mechanism for
		sharing call appearances across access devices. Although SIP (RFC 3261)
		by itself offers no inherent semantics for supporting SCA features, when
		coupled with an appropriate instantiation of the &#8220;SIP Specific Event Notification&#8221;
		framework (RFC 3265), these services can be deployed quite easily in a 
		distributed network.
		</p><p>
		A shared line is an address of record managed by central
		controlling element, such as an application server. The application server 
		allows multiple endpoints to register locations against the address of record.
		The application server is responsible for policing who can register and who 
		cannot register against the shared line.
		</p><p>
		The module enables the handling of "call-info" and "line-seize"
		events inside the presence module. It is used with the general event
		handling module: presence and it constructs and adds "Call-Info" headers
		to notification events.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248003"></a>1.2. Usage modes</h2></div></div></div><p>
		The module can be used in two ways (depending on who is doing the
		publishing of the "call-info" data:
		</p><div class="itemizedlist"><ul type="disc"><li><p>external publishing - the "call-info" data
			is received from a third party via SIP PUBLISH requests. In this
			mode, the modules simply distributes the SCA info, it is not 
			producing any of it - a third-party application must publish 
			"call-info" events to the presence server.
			</p></li><li><p>internal publishing - the "call-info" data
			is internally generated by the module, based on the information
			received from the dialog module - what calls are using what 
			line/index, what is the state of the call, etc. There is no SIP
			PUBLISH in this case and there is no need for a third-party - 
			the module is self-sufficient and stand alone as functionality.
			</p></li></ul></div><p>The used mode can be controlled via the module parameter 
		"disable_dialog_support_for_sca" - see below in the parameter's
		section.
		</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249592"></a>1.2.1. External publishing</h3></div></div></div><p>
			The module does not currently implement any authorization
			rules.  It assumes that publish requests are only issued by
			a third-party application and subscribe requests only by
			subscriber to call-info and line-seize events.  Authorization
			can thus be easily done by OpenSIPS configuration file before
			calling handle_publish() and handle_subscribe() functions.
			</p><p>
			To get better understanding on how the module works please take a
			look at the follwing figure:
			</p><pre class="programlisting">

   caller       proxy &amp;   callee        watcher        publisher
alice@example  presence  bob@example  watcher@example
                 server                       
     |             |           |           |              |
     |             |&lt;-----SUBSCRIBE bob----|              |
     |             |------200 OK----------&gt;|              |
     |             |------NOTIFY----------&gt;|              |
     |             |&lt;-----200 OK-----------|              |
     |             |           |           |              |
     |--INV bob---&gt;|           |           |              |
     |             |--INV bob-&gt;|           |              |
     |             |&lt;-100------|           |              |
     |             |&lt;-----PUBLISH(alerting)---------------|
     |             |------200 OK-------------------------&gt;|
     |             |------NOTIFY----------&gt;|              |
     |             |&lt;-----200 OK-----------|              |
     |             |           |           |              |
     |             |&lt;-180 ring-|           |              |
     |&lt;--180 ring--|           |           |              |
     |             |           |           |              |
     |             |           |           |              |
     |             |&lt;-200 OK---|           |              |
     |&lt;--200 OK----|           |           |              |
     |             |&lt;-----PUBLISH(active)-----------------|
     |             |------200 OK-------------------------&gt;|
     |             |------NOTIFY----------&gt;|              |
     |             |&lt;-----200 OK-----------|              |
     |             |           |           |              |

			</pre><p>
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				The watcher subscribes the "Event: dialog" of Bob.
				</p></li><li><p>
				Alice calls Bob.
				</p></li><li><p>
				The publisher is publishing the "alerting" state for Bob.
				</p></li><li><p>
				PUBLISH is received and handled by presence module.
				Presence module updates the "presentity".
				Presence module checks for active watchers of the presentity.
				The active watcher is notified via a NOTIFY SIP request.
				</p></li><li><p>
				Bob answers the call.
				</p></li><li><p>
				The publisher is publishing the "active" state for Bob.
				</p></li><li><p>
				PUBLISH is received and handled by presence module.
				Presence module updates the "presentity".
				Presence module checks for active watchers of the presentity.
				The active watcher is notified via a NOTIFY SIP request.
				</p></li></ul></div><p>
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249635"></a>1.2.2. Internal publishing</h3></div></div></div><p>
			In this mode, the module requires the "dialog" module to be
			loaded into OpenSIPS. All the publishing will be automatically
			done (the modules will exchange data directly via C API).
			</p><p>
			From presence perspective, the OpenSIPS script must be configured
			to handle the SUBSCRIBE requests only (there is no need for PUBLISH
			handling as there is no SIP publishing in this mode). So be sure
			to use the "handle_subscribe()" function (from presence module) in
			the script.
			</p><p>
			To trigger the internal publishing (from the dialog module) for a
			certain call, use the "sca_set_calling_line()" or
			"sca_set_called_line()" functions from the script when handling a
			new call. These functions will do all the work (creating dialog, 
			setting the internal publishing, etc) - you just need to use them
			and eventually specify the name of the line (if other then the one
			from the SIP INVITE) - see the below documentation.
			</p><p>
			LIMITATIONS : in this mode, the module does not really check if the
			line exists or not (like defined) - it blindly trust the traffic;
			also there is no check on how many indexes are for each line. Such
			information (lines and indexes) are not provisioned into the module,
			but the module will dynamically accept and handle any line and index
			based on the SIP traffic.
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293400"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293405"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
			The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>presence</em></span>.
				</p></li><li><p>
				<span class="emphasis"><em>dialog</em></span>.
				</p></li></ul></div><p>
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293437"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
			None.
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293448"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293453"></a>1.4.1. <code class="varname">call_info_timeout_notification</code> (int)</h3></div></div></div><p>
			Enables or disables call_info event timeout notifications.
			</p><p><span class="emphasis"><em>Default value is &#8220;<span class="quote">1</span>&#8221;</em></span> (enabled).</p><div class="example"><a name="id293471"></a><p class="title"><b>Example 1.1. Set <code class="varname">call_info_timeout_notification</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("presence_callinfo", "call_info_timeout_notification", 0)
...
			</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293486"></a>1.4.2. <code class="varname">line_seize_timeout_notification</code> (int)</h3></div></div></div><p>
			Enables or disables line_seize event timeout notifications.
			</p><p><span class="emphasis"><em>Default value is &#8220;<span class="quote">0</span>&#8221;</em></span> (disabled).</p><div class="example"><a name="id293504"></a><p class="title"><b>Example 1.2. Set <code class="varname">line_seize_timeout_notification</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("presence_callinfo", "line_seize_timeout_notification", 1)
...
			</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293520"></a>1.4.3. <code class="varname">disable_dialog_support_for_sca</code> (int)</h3></div></div></div><p>
			Disables the internal publishing of the "call-info" events (generated by the dialog module).
			The publishing is expected to be done via SIP PUBLISH from a third-party. See
			the wroking mode described in the beginning of this document.
			</p><p><span class="emphasis"><em>Default value is &#8220;<span class="quote">0</span>&#8221;</em></span> (not disabled).</p><div class="example"><a name="id293540"></a><p class="title"><b>Example 1.3. Set <code class="varname">disable_dialog_support_for_sca</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("presence_callinfo", "disable_dialog_support_for_sca", 1)
...
			</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293556"></a>1.4.4. <code class="varname">line_hash_size</code> (int)</h3></div></div></div><p>
			Allows you to controll the size of the internal hash table used for storing the
			information about the lines and indexes (in the internal publishing mode).
			</p><p>
			The value must be a power of 2. You may consider increasing the value if using
			a large set of lines (&gt;1000).
			</p><p><span class="emphasis"><em>Default value is &#8220;<span class="quote">64</span>&#8221;</em></span>.</p><div class="example"><a name="id293580"></a><p class="title"><b>Example 1.4. Set <code class="varname">line_hash_size</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("presence_callinfo", "line_hash_size", 128)
...
			</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293597"></a>1.5. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293602"></a>1.5.1. 
			<code class="function">sca_set_calling_line([line])</code>
			</h3></div></div></div><p>
			The function (to be used only in internal publishing mode) is setting
			for the current new call (initinal INVITE) the outbound line - the line
			used for calling out.
			</p><p>
			If no parameter is provided, the name of the line is taken from the
			SIP FROM header of the INVITE. You can override that by providing 
			the name of the line a parameter - be careful as the value must be
			a SIP URI ! Variables are accepted.
			</p><p>
			This function can be used from REQUEST_ROUTE.
			</p><div class="example"><a name="id293626"></a><p class="title"><b>Example 1.5. <code class="function">sca_set_calling_line()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
	if (is_method("INVITE") and !has_totag()) {
		sca_set_calling_line();
	}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293643"></a>1.5.2. 
			<code class="function">sca_set_called_line([line])</code>
			</h3></div></div></div><p>
			The function (to be used only in internal publishing mode) is setting
			for the current new call (initinal INVITE) the inbound line - the line
			the call was received on.
			</p><p>
			If no parameter is provided, the name of the line is taken from the
			SIP RURI of the INVITE. You can override that by providing 
			the name of the line a parameter - be careful as the value must be
			a SIP URI ! Variables are accepted.
			</p><p>
			This function can be used from REQUEST_ROUTE.
			</p><div class="example"><a name="id293667"></a><p class="title"><b>Example 1.6. <code class="function">sca_set_called_line()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
	if (is_method("INVITE") and !has_totag()) {
		sca_set_called_line();
	}
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
