<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Regex Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id283990"></a>Regex Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Iñaki</span> <span class="surname">Baz Castillo</span></h3><code class="email">&lt;<a class="email" href="mailto:ibc@aliax.net">ibc@aliax.net</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Iñaki</span> <span class="surname">Baz Castillo</span></h3><code class="email">&lt;<a class="email" href="mailto:ibc@aliax.net">ibc@aliax.net</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2009 Iñaki Baz Castillo</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id280608">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id267800">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id249559">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249565">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249581">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249195">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249201">1.3.1. <code class="varname">file</code> (string)</a></span></dt><dt><span class="section"><a href="#id249240">1.3.2. <code class="varname">max_groups</code> (int)</a></span></dt><dt><span class="section"><a href="#id248318">1.3.3. <code class="varname">group_max_size</code> (int)</a></span></dt><dt><span class="section"><a href="#id248357">1.3.4. <code class="varname">pcre_caseless</code> (int)</a></span></dt><dt><span class="section"><a href="#id293380">1.3.5. <code class="varname">pcre_multiline</code> (int)</a></span></dt><dt><span class="section"><a href="#id293427">1.3.6. <code class="varname">pcre_dotall</code> (int)</a></span></dt><dt><span class="section"><a href="#id293466">1.3.7. <code class="varname">pcre_extended</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293507">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293512">1.4.1. 
				<code class="function">pcre_match (string, pcre_regex)</code>
			</a></span></dt><dt><span class="section"><a href="#id293600">1.4.2. 
				<code class="function">pcre_match_group (string [, group])</code>
			</a></span></dt></dl></dd><dt><span class="section"><a href="#id293772">1.5. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293778">1.5.1. 
				<code class="function">regex_reload</code>
			</a></span></dt></dl></dd><dt><span class="section"><a href="#id293815">1.6. Installation and Running</a></span></dt><dd><dl><dt><span class="section"><a href="#file-format-id">1.6.1. File format</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249223">Set <code class="varname">file</code> parameter</a></dt><dt>1.2. <a href="#id248301">Set <code class="varname">max_groups</code> parameter</a></dt><dt>1.3. <a href="#id248340">Set <code class="varname">group_max_size</code> parameter</a></dt><dt>1.4. <a href="#id293364">Set <code class="varname">pcre_caseless</code> parameter</a></dt><dt>1.5. <a href="#id293411">Set <code class="varname">pcre_multiline</code> parameter</a></dt><dt>1.6. <a href="#id293450">Set <code class="varname">pcre_dotall</code> parameter</a></dt><dt>1.7. <a href="#id293490">Set <code class="varname">pcre_extended</code> parameter</a></dt><dt>1.8. <a href="#id293563">
					<code class="function">pcre_match</code> usage (forcing case insensitive)
				</a></dt><dt>1.9. <a href="#id293581">
					<code class="function">pcre_match</code> usage (using "end of line" symbol)
				</a></dt><dt>1.10. <a href="#id293753">
					<code class="function">pcre_match_group</code> usage
				</a></dt><dt>1.11. <a href="#id293940">regex file</a></dt><dt>1.12. <a href="#id293969">Using with pua_usrloc</a></dt><dt>1.13. <a href="#id293988">Incorrect groups file</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id280608"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id267800"></a>1.1. Overview</h2></div></div></div><p>
			This module offers matching operations against regular expressions using the
			powerful <a class="ulink" href="http://www.pcre.org/" target="_top">PCRE</a> library.
		</p><p>
			A text file containing regular expressions categorized in groups is compiled
			when the module is loaded, storing the compiled PCRE objects in an array. A
			function to match a string or pseudo-variable against any of these groups is
			provided. The text file can be modified and reloaded at any time via a MI command.
			The module also offers a function to perform a PCRE matching operation against a
			regular expression provided as function parameter.
		</p><p>
			For a detailed list of PCRE features read the
			<a class="ulink" href="http://www.pcre.org/pcre.txt" target="_top">man page</a> of the library.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249559"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249565"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
				The following modules must be loaded before this module:
				</p><div class="itemizedlist"><ul type="disc"><li><p>
							<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
						</p></li></ul></div><p>
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249581"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
				The following libraries or applications must be installed before running
				OpenSIPS with this module loaded:
				</p><div class="itemizedlist"><ul type="disc"><li><p>
							<span class="emphasis"><em>libpcre-dev - the development libraries of <a class="ulink" href="http://www.pcre.org/" target="_top">PCRE</a></em></span>.
						</p></li></ul></div><p>
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249195"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249201"></a>1.3.1. <code class="varname">file</code> (string)</h3></div></div></div><p>
				Text file containing the regular expression groups. It must be set in order
				to enable the group matching function.
			</p><p>
				<span class="emphasis"><em>Default value is &#8220;<span class="quote">NULL</span>&#8221;.</em></span>
			</p><div class="example"><a name="id249223"></a><p class="title"><b>Example 1.1. Set <code class="varname">file</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("regex", "file", "/etc/opensips/regex_groups")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249240"></a>1.3.2. <code class="varname">max_groups</code> (int)</h3></div></div></div><p>
				Max number of regular expression groups in the text file.
			</p><p>
				<span class="emphasis"><em>Default value is &#8220;<span class="quote">20</span>&#8221;.</em></span>
			</p><div class="example"><a name="id248301"></a><p class="title"><b>Example 1.2. Set <code class="varname">max_groups</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("regex", "max_groups", 40)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248318"></a>1.3.3. <code class="varname">group_max_size</code> (int)</h3></div></div></div><p>
				Max content size of a group in the text file.
			</p><p>
				<span class="emphasis"><em>Default value is &#8220;<span class="quote">8192</span>&#8221;.</em></span>
			</p><div class="example"><a name="id248340"></a><p class="title"><b>Example 1.3. Set <code class="varname">group_max_size</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("regex", "group_max_size", 16384)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248357"></a>1.3.4. <code class="varname">pcre_caseless</code> (int)</h3></div></div></div><p>
				If this options is set, matching is done caseless. It is equivalent to
				Perl's /i option, and it can be changed within a pattern by a (?i) or
				(?-i) option setting.
			</p><p>
				<span class="emphasis"><em>Default value is &#8220;<span class="quote">0</span>&#8221;.</em></span>
			</p><div class="example"><a name="id293364"></a><p class="title"><b>Example 1.4. Set <code class="varname">pcre_caseless</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("regex", "pcre_caseless", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293380"></a>1.3.5. <code class="varname">pcre_multiline</code> (int)</h3></div></div></div><p>
				By default, PCRE treats the subject string as consisting of a single line
				of characters (even if it actually contains newlines). The "start of line"
				metacharacter (^) matches only at the start of the string, while the "end
				of line" metacharacter ($) matches only at the end of the string, or before
				a terminating newline.
			</p><p>
				When this option is set, the "start of line" and "end of line" constructs
				match immediately following or immediately before internal newlines in the
				subject string, respectively, as well as at the very start and end. This is
				equivalent to Perl's /m option, and it can be changed within a pattern by a
				(?m) or (?-m) option setting. If there are no newlines in a subject string,
				or no occurrences of ^ or $ in a pattern, setting this option has no effect.
			</p><p>
				<span class="emphasis"><em>Default value is &#8220;<span class="quote">0</span>&#8221;.</em></span>
			</p><div class="example"><a name="id293411"></a><p class="title"><b>Example 1.5. Set <code class="varname">pcre_multiline</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("regex", "pcre_multiline", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293427"></a>1.3.6. <code class="varname">pcre_dotall</code> (int)</h3></div></div></div><p>
				If this option is set, a dot metacharater in the pattern matches all characters,
				including those that indicate newline. Without it, a dot does not match when
				the current position is at a newline. This option is equivalent to Perl's /s
				option, and it can be changed within a pattern by a (?s) or (?-s) option setting.
			</p><p>
				<span class="emphasis"><em>Default value is &#8220;<span class="quote">0</span>&#8221;.</em></span>
			</p><div class="example"><a name="id293450"></a><p class="title"><b>Example 1.6. Set <code class="varname">pcre_dotall</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("regex", "pcre_dotall", 1)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293466"></a>1.3.7. <code class="varname">pcre_extended</code> (int)</h3></div></div></div><p>
				If this option is set, whitespace data characters in the pattern are totally
				ignored except when escaped or inside a character class. Whitespace does not
				include the VT character (code 11). In addition, characters between an
				unescaped # outside a character class and the next newline, inclusive, are
				also ignored. This is equivalent to Perl's /x option, and it can be changed
				within a pattern by a (?x) or (?-x) option setting.
			</p><p>
				<span class="emphasis"><em>Default value is &#8220;<span class="quote">0</span>&#8221;.</em></span>
			</p><div class="example"><a name="id293490"></a><p class="title"><b>Example 1.7. Set <code class="varname">pcre_extended</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("regex", "pcre_extended", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293507"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293512"></a>1.4.1. 
				<code class="function">pcre_match (string, pcre_regex)</code>
			</h3></div></div></div><p>
				Matches the given string parameter against the regular expression pcre_regex,
				which is compiled into a PCRE object. Returns TRUE if it matches, FALSE
				otherwise.
			</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
						<span class="emphasis"><em>string</em></span> - String or pseudo-variable to compare.
					</p></li><li><p>
						<span class="emphasis"><em>pcre_regex</em></span> - Regular expression to be compiled
						in a PCRE object. It can be a string or pseudo-variable.
					</p></li></ul></div><p>
				NOTE: To use the "end of line" symbol '$' in the pcre_regex parameter use '$$'.
			</p><p>
				This function can be used from REQUEST_ROUTE, FAILURE_ROUTE, ONREPLY_ROUTE,
				BRANCH_ROUTE and LOCAL_ROUTE.
			</p><div class="example"><a name="id293563"></a><p class="title"><b>Example 1.8. 
					<code class="function">pcre_match</code> usage (forcing case insensitive)
				</b></p><div class="example-contents"><pre class="programlisting">
...
if (pcre_match("$ua", "(?i)^twinkle")) {
    xlog("L_INFO", "User-Agent matches\n");
}
...
</pre></div></div><br class="example-break"><div class="example"><a name="id293581"></a><p class="title"><b>Example 1.9. 
					<code class="function">pcre_match</code> usage (using "end of line" symbol)
				</b></p><div class="example-contents"><pre class="programlisting">
...
if (pcre_match("$rU", "^user[1234]$$")) {  # Will be converted to "^user[1234]$"
    xlog("L_INFO", "RURI username matches\n");
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293600"></a>1.4.2. 
				<code class="function">pcre_match_group (string [, group])</code>
			</h3></div></div></div><p>
				It uses the groups readed from the text file
				(see <a class="xref" href="#file-format-id" title="1.6.1. File format">Section 1.6.1, &#8220;File format&#8221;</a>) to match the given string
				parameter against the compiled regular expression in group number group.
				Returns TRUE if it matches, FALSE otherwise.
			</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
						<span class="emphasis"><em>string</em></span> - String or pseudo-variable to compare.
					</p></li><li><p>
						<span class="emphasis"><em>group</em></span> - Number of group to use in the operation.
						If not specified then 0 (the first group) is used.
					</p></li></ul></div><p>
				This function can be used from REQUEST_ROUTE, FAILURE_ROUTE, ONREPLY_ROUTE,
				BRANCH_ROUTE and LOCAL_ROUTE.
			</p><div class="example"><a name="id293753"></a><p class="title"><b>Example 1.10. 
					<code class="function">pcre_match_group</code> usage
				</b></p><div class="example-contents"><pre class="programlisting">
...
if (pcre_match_group("$rU", "2")) {
    xlog("L_INFO", "RURI username matches group 2\n");
}
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293772"></a>1.5. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293778"></a>1.5.1. 
				<code class="function">regex_reload</code>
			</h3></div></div></div><p>
				Causes regex module to re-read the content of the text file
				and re-compile the regular expressions. The number of groups
				in the file can be modified safely.
			</p><p>
				Name: <span class="emphasis"><em>regex_reload</em></span>
			</p><p>Parameters: <span class="emphasis"><em>none</em></span></p><p>
				MI FIFO Command Format:
			</p><pre class="programlisting">
:regex_reload:_reply_fifo_file_
_empty_line_
</pre></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293815"></a>1.6. Installation and Running</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="file-format-id"></a>1.6.1. File format</h3></div></div></div><p>
				The file contains regular expressions categorized in groups. Each
				group starts with "[number]" line. Lines starting by space, tab,
				CR, LF or # (comments) are ignored. Each regular expression must
				take up just one line, this means that a regular expression can't
				be splitted in various lines.
			</p><p>
				An example of the file format would be the following:
			</p><div class="example"><a name="id293940"></a><p class="title"><b>Example 1.11. regex file</b></p><div class="example-contents"><pre class="programlisting">
### List of User-Agents publishing presence status
[0]

# Softphones
^Twinkle/1
^X-Lite
^eyeBeam
^Bria
^SIP Communicator
^Linphone

# Deskphones
^Snom

# Others
^SIPp
^PJSUA


### Blacklisted source IP's
[1]

^190\.232\.250\.226$
^122\.5\.27\.125$
^86\.92\.112\.


### Free PSTN destinations in Spain
[2]

^1\d{3}$
^((\+|00)34)?900\d{6}$
</pre></div></div><br class="example-break"><p>
				The module compiles the text above to the following regular
				expressions:
			</p><pre class="programlisting">
group 0: ((^Twinkle/1)|(^X-Lite)|(^eyeBeam)|(^Bria)|(^SIP Communicator)|
          (^Linphone)|(^Snom)|(^SIPp)|(^PJSUA))
group 1: ((^190\.232\.250\.226$)|(^122\.5\.27\.125$)|(^86\.92\.112\.))
group 2: ((^1\d{3}$)|(^((\+|00)34)?900\d{6}$))
</pre><p>
				The first group can be used to avoid auto-generated PUBLISH (pua_usrloc
				module) for UA's already supporting presence:
			</p><div class="example"><a name="id293969"></a><p class="title"><b>Example 1.12. Using with pua_usrloc</b></p><div class="example-contents"><pre class="programlisting">
route[REGISTER] {
    if (! pcre_match_group("$ua", 0)) {
        xlog("L_INFO", "Auto-generated PUBLISH for $fu ($ua)\n");
        pua_set_publish();
    }
    save("location");
    exit;
}
</pre></div></div><br class="example-break"><p>
				NOTE: It's important to understand that the numbers in each group
				header ([number]) must start by 0. If not, the real group number
				will not match the number appearing in the file. For example, the
				following text file:
			</p><div class="example"><a name="id293988"></a><p class="title"><b>Example 1.13. Incorrect groups file</b></p><div class="example-contents"><pre class="programlisting">
[1]
^aaa
^bbb

[2]
^ccc
^ddd
</pre></div></div><br class="example-break"><p>
				will generate the following regular expressions:
			</p><pre class="programlisting">
group 0: ((^aaa)|(^bbb))
group 1: ((^ccc)|(^ddd))
</pre><p>
				Note that the real index doesn't match the group number in the file. This
				is, compiled group 0 always points to the first group in the file, regardless
				of its number in the file. In fact, the group number appearing in the file is
				used for nothing but for delimiting different groups.
			</p><p>
				NOTE: A line containing a regular expression cannot start by '[' since it
				would be treated as a new group. The same for lines starting by space, tab,
				or '#' (they would be ignored by the parser). As a workaround, using brackets
				would work:
			</p><pre class="programlisting">
[0]
([0-9]{9})
( #abcde)
( qwerty)
</pre></div></div></div></div></body></html>
